<?php
$savepath = dirname(__FILE__).'/weight.db'; // ログの保存先
$script_name = $_SERVER["SCRIPT_NAME"];     // このプログラムのパス
// SQLのひな型
$create_query = <<< ___SQL___
    CREATE TABLE IF NOT EXISTS weight_list (
        weight_id    INTEGER PRIMARY KEY, /* 体重ID */
        weight       REAL,                /* 体重 */
        ctime        INTEGER              /* 投稿日時 */
    );
___SQL___;
$insert_query = <<< __SQL__
    INSERT INTO weight_list (weight, ctime)
        VALUES (?, ?);
__SQL__;
$select_query = <<< __SQL__
    SELECT * FROM weight_list ORDER BY weight_id DESC;
__SQL__;
// データベースへの接続
try {
    $db = new PDO("sqlite:$savepath");
} catch (PDOException $e) {
    echo "接続失敗:".$e->getMessage(); exit;
}
$db->exec($create_query);
// 書き込み処理があったか？
if (isset($_GET["weight"])) {
    $w = floatval($_GET["weight"]);
    if ($w <= 30) { echo "体重を入力してください。"; exit; }
    // データベースに挿入
    $stmt = $db->prepare($insert_query);
    $stmt->execute(array($w, time()));
    header("location: $script_name"); exit; // リロードする
}
// 書き込みフォームの表示
echo <<< __FORM__
<h3>体重記録プログラム</h3>
<form action="$script_name" method="GET">
体重:<input type="text" name="weight" />kg
<input type="submit" value="書込" />
</form>
__FORM__;
// ログの表示
$stmt = $db->query($select_query);
foreach ($stmt as $row) {
    $weight = $row["weight"];
    $ctime  = date("Y/m/d H:i:s", $row["ctime"]);
    echo "<div>($ctime) {$weight}kg</div>";
}
