<?php
$savepath = "hyakunin.db";  // データベースの保存先
$csvpath  = "hyakunin.csv"; // CSVファイルのパス
// 日本語でUTF-8を使うことを明示
mb_language("Japanese");
mb_internal_encoding("utf-8");
// SQLのひな型
$create_query = <<< __SQL__
    CREATE TABLE songs (
        song_id    INTEGER PRIMARY KEY,
        kami       TEXT, /* 上の句 */
        simo       TEXT, /* 下の句 */
        author     TEXT  /* 作者 */
    );
__SQL__;
$insert_query = <<< __SQL__
    INSERT INTO songs (song_id,kami,simo, author)
               VALUES (?, ?, ?, ?)
__SQL__;
// データベースと接続
$db = new PDO("sqlite:$savepath");
$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
// テーブルを定義
$db->exec($create_query);
// CSVファイルを一行ずつ処理
$db->beginTransaction();
$stmt = $db->prepare($insert_query);
$fp = fopen($csvpath, "r");
fgets($fp); // 先頭の一行はヘッダなので捨てる
while (($line = fgets($fp)) != false) {
    $line = mb_convert_encoding($line, "utf-8", "sjis");
    $line = trim($line);
    list($song_id,$kami,$simo,$n1,$n2,$author) = explode(",", $line);
    $song_id = intval($song_id);
    $stmt->execute(array($song_id, $kami, $simo, $author));
    echo $song_id."\n"; // 経過報告
}
$db->commit();
echo "ok!";
