<?php
// HTMLのテンプレートを出力する関数群
function show_html_header($title = "") {
    if ($title != "") $title .= "-";
    $title_h = htmlspecialchars($title);
    // ログインしているなら、ログアウトのリンクを表示する
    $menu_link = "";
    if (is_logined ()) {
        if (is_admin ()) {
            $menu_link .= "[<a href='admin.php'>管理ページ</a>] ";
        }
        $menu_link .= "[<a href='index.php'>TOP</a>] ";
        $menu_link .= "[<a href='group.php'>グループ</a>] ";
        $menu_link .= "[<a href='login.php?m=logout'>ログアウト</a>]";
    }

    // スマートフォンならば、CSSを切り替える
    $cssfile = is_smartphone() ? "sikkari-mobile.css" : "sikkari.css";
    $subtitle = is_smartphone() ? "mobile" : "";

    echo <<< __HEAD__
<!DOCTYPE html>
<html>
<head>
<meta name="viewport"
  content="width=320,user-scalable=yes,
           initial-scale=1.0,maximum-scale=3.0" />
<meta charset="utf-8" />
<title>{$title_h}シッカリスト</title>
<link rel="STYLESHEET" href="$cssfile" type="text/css" />
</head>
<body>
<div id="page_head">
<div class="topmenu_left">シッカリスト{$subtitle}</div>
<div class="topmenu">$menu_link</div>
</div>
__HEAD__;
}

function show_html_footer() {
    echo <<< __FOOT__
</body>
</html>
__FOOT__;
}

// スマートフォンかどうかを確かめる関数
function is_smartphone() {
    $ua = $_SERVER["HTTP_USER_AGENT"];
    if (strpos($ua, "Android"))	return true;
    if (strpos($ua, "iPhone")) 	return true;
    if (strpos($ua, "iPod")) 	return true;
    if (strpos($ua, "Windows Phone")) return true;
    return false;
}



