<?php
error_reporting(E_ALL);             // PEARのエラーを無視する
require_once "Text/CAPTCHA.php";    // CAPTCHAライブラリの取り込み
$savepath = dirname(__FILE__).'/log.txt'; // ログの保存先
session_start();                    // セッションの開始
// 処理を分岐
$m = isset($_GET["m"]) ? $_GET["m"] : "";
if ($m == "write") { m_write(); }
              else { m_show();  }
// ログの表示
function m_show() {
    global $savepath;
    show_form();
    if (file_exists($savepath)) {
        $txt = file_get_contents($savepath);
        echo "<ul>$txt</ul>";
    }
}
// 書込フォームの表示
function show_form() {
    // セッションIDを元に画像ファイル名を決定
    $captcha_png = "./captcha-img/".session_id().".png";
    // CAPTCHAオブジェクトを生成
    $cap = Text_Captcha::factory('Image');
    $font_setting = array( // フォントの指定
        'font_size' => 20,
        'font_path' => './',
        'font_file' => 'DroidSerif.ttf'
    );
    $cap->init(300, 60, null, $font_setting); // 設定
    $_SESSION['phrase'] = $cap->getPhrase();  // フレーズをセッションに保存
    $png = $cap->getCAPTCHAAsPNG();           // CAPTCHA用の画像を取得
    file_put_contents($captcha_png, $png);    // 画像を保存
    $self = $_SERVER["SCRIPT_NAME"];
    echo <<< __FORM__
<form action="$self" method="get">
    <input type="hidden" name="m" value="write" />
    <div>名前: <input type="text" name="name" value="" size="20" /></div>
    <div>本文: <input type="text" name="body" value="" size="60" /></div>
    <div><img src="$captcha_png" /><br/>
    上の文字を入力: <input type="text" name="captcha" value="" /></div>
    <div><input type="submit" value="書込" /></div>
</form>
__FORM__;
}
// ファイルへメッセージを保存
function m_write() {
    global $savepath;
    // パラメータの取得
    $name    = isset($_GET["name"]) ? $_GET["name"] : "";
    $body    = isset($_GET["body"]) ? $_GET["body"] : "";
    $captcha = isset($_GET["captcha"]) ? $_GET["captcha"] : "";
    if ($name == "" || $body == "" || $captcha == "") {
        die("入力に不備があります");
    }
    // CAPTCHAが正しいかどうか判別する
    if ($_SESSION["phrase"] !== $captcha) {
        die("画像認証(CAPTCHA)に失敗。");
    }
    // 追記保存
    $fp = fopen($savepath, "a");
    $line = htmlspecialchars("$name:$body");
    fputs($fp, "<li>$line</li>\n");
    // ページをリロード
    header("location: ".$_SERVER["SCRIPT_NAME"]);
}
